<template>
  <q-layout view="lHh Lpr lFf">
    <q-header elevated>
      <q-toolbar>
        <q-btn
          flat
          dense
          round
          @click="leftDrawerOpen = !leftDrawerOpen"
          icon="menu"
          aria-label="Menu"
        />

        <q-toolbar-title>
          Admantica Character Sheet
        </q-toolbar-title>

      </q-toolbar>
    </q-header>

    <q-drawer
      v-model="leftDrawerOpen"
      show-if-above
      bordered
      content-class="bg-grey-2"
    >
      <q-list>

        <q-item clickable tag="router-link" to="/">
          <q-item-section avatar>
            <q-icon name="home" />
          </q-item-section>
          <q-item-section>
            <q-item-label>Home / How To ?</q-item-label>
          </q-item-section>
        </q-item>

        <q-item clickable tag="router-link" to="/characters">
          <q-item-section avatar>
            <q-icon name="person" />
          </q-item-section>
          <q-item-section>
            <q-item-label>My Characters</q-item-label>
            <q-item-label caption>List all Characters</q-item-label>
          </q-item-section>
        </q-item>

        <q-item>
          <q-item-section avatar>
            <q-icon name="cloud_download" />
          </q-item-section>
          <q-item-section>
            <q-item-label>Save my Characters</q-item-label>
            <q-btn color="info" label="Download" @click="exportJson" />
          </q-item-section>
        </q-item>

        <q-item>
          <q-item-section avatar>
            <q-icon  name="cloud_upload" />
          </q-item-section>
          <q-item-section>
            <q-item-label>Load Characters from File</q-item-label>
            <q-btn color="info" label="Choose File" @click="uploaderOpen = !uploaderOpen" />
          </q-item-section>

        </q-item>
      </q-list>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>

    <q-dialog v-model="uploaderOpen">
      <q-card>
        <q-card-section class="row items-center">
          <q-avatar icon="save"/>
          <span class="q-ml-sm">Upload your backup to overwrite application storage</span>
            <file-reader
            title="Backup File"
            @done="importFinished"
            />
        </q-card-section>
      </q-card>
    </q-dialog>

  </q-layout>
</template>

<script>
import FileReader from "../components/fileReader.vue";
export default {

  name: 'MyLayout',
  components: {
    'file-reader': FileReader
  },

  data () {
    return {
      leftDrawerOpen: false,
      uploaderOpen: false
    }
  },
  methods: {
    exportJson: function () {
      var link = document.createElement('a');
      link.download = 'characters.json';
      var blob = new Blob([JSON.stringify(localStorage)], { type: 'text/plain' });
      link.href = window.URL.createObjectURL(blob);
      link.click();
      link.parentNode.removeChild(link);
      this.$router.go(0);
    },
    importFinished: function() {
      this.leftDrawerOpen = false;
      this.uploaderOpen = false;
      this.$router.push("/characters");
    }

  }
}
</script>
